#include "common.h"
#include "ProgressDlg.h"

LRESULT CProgressDialog::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	m_Info=GetDlgItem(IDC_STATIC_INFO);
	m_Progress=GetDlgItem(IDC_PROGRESS_STATUS);
	m_Info.GetWindowText(m_strInfo);
	GetWindowText(m_strTitle);
	m_TotalFiles=0;
	m_CurrentIndex=0;
	m_Progress.SetPos(0);

	//_CAȌꏊʍɂ
	SetWindowPos(NULL,100,100,0,0,SWP_NOSIZE);


	//bZ[WtB^̐ݒ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);
	return TRUE;
}

void CProgressDialog::OnDestroy()
{
	//bZ[WtB^̏
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->RemoveMessageFilter(this);
}

void CProgressDialog::SetTotalFileCount(int nFiles)
{
	m_TotalFiles=nFiles;
	m_Progress.SetRange(0,nFiles);
	m_Progress.SetPos(0);
}

void CProgressDialog::SetNextState(LPCTSTR lpszFile)
{
	m_CurrentIndex++;
	//̃t@C𖾎
	CString tmp;
	tmp.Format(m_strInfo,lpszFile);
	m_Info.SetWindowText(tmp);

	//̃t@C\
	tmp.Format(m_strTitle,m_CurrentIndex,m_TotalFiles);
	SetWindowText(tmp);

	//vOXo[ݒ
	m_Progress.SetPos(m_CurrentIndex-1);
	m_Progress.UpdateWindow();
}
