#pragma once
#include "DataObject.h"
#include "DropSource.h"
#include "STGMEDIUM.h"
#include "../dirtree.h"
#include "../../Components/TemporaryDirMgr.h"

//Written by Claybird http://claybird.hp.infoseek.co.jp/

//hbO&hbv
class COLEDnDSource{
protected:
	HDROP CreateHDrop(std::list<CString>&);

	void CreateMedium(CLIPFORMAT cfFormat, HANDLE hObject, FORMATETC *pFormatetc, STGMEDIUM *pmedium);

	CTemporaryDirectoryManager &r_TempDirManager;
public:
	bool DragDrop(LPCTSTR,CArchiverDLL*,std::list<CDirectoryTree*>&,CDirectoryTree *Base);
	COLEDnDSource(CTemporaryDirectoryManager &r):r_TempDirManager(r){}
	virtual ~COLEDnDSource(){}
};
