#include "common.h"
#include "WaitDialog.h"

LRESULT CWaitDialog::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	Static_MessageString=GetDlgItem(IDC_STATIC_WAIT_MESSAGE);
	Static_Icon=GetDlgItem(IDC_STATIC_ANIMATION_ICON);

	CImageList ImageList;
	ImageList.Create(MAKEINTRESOURCE(IDB_BITMAP_ANIMATION),32,1,RGB(0,0,0));
	int IconCount=ImageList.GetImageCount();
	m_CurrentIconNumber=0;
	m_IconArray.resize(IconCount);
	for(int i=0;i<IconCount;i++){
		m_IconArray[i]=ImageList.ExtractIcon(i);
	}
	m_LastTime=0;

	// eEBhE̒ɔzu
	CenterWindow();

	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);
	pLoop->AddIdleHandler(this);

	return TRUE;
}

void CWaitDialog::OnDestroy()
{
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->RemoveMessageFilter(this);
	pLoop->RemoveIdleHandler(this);

	m_IconArray.clear();
}
