#include "common.h"
#include "config_7z.h"

//=================
// 7Zʐݒ
//=================
LRESULT CConfig7Z::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	//----------------
	// k`̑I
	//----------------
	//vZbgg
	Check_UsePreset=GetDlgItem(IDC_CHECK_7Z_USE_PRESET);
	Check_UsePreset.SetCheck(Config.SEVEN_ZIP.UsePreset);
	//蓮ݒ肷邩
	Radio_CompressType[SEVEN_ZIP_COMPRESS_LZMA]=GetDlgItem(IDC_RADIO_7Z_METHOD_LZMA);
	Radio_CompressType[SEVEN_ZIP_COMPRESS_PPMD]=GetDlgItem(IDC_RADIO_7Z_METHOD_PPMD);
	Radio_CompressType[SEVEN_ZIP_COMPRESS_BZIP2]=GetDlgItem(IDC_RADIO_7Z_METHOD_BZIP2);
	Radio_CompressType[SEVEN_ZIP_COMPRESS_DEFLATE]=GetDlgItem(IDC_RADIO_7Z_METHOD_DEFLATE);
	Radio_CompressType[SEVEN_ZIP_COMPRESS_COPY]=GetDlgItem(IDC_RADIO_7Z_METHOD_COPY);

	Radio_CompressType[Config.SEVEN_ZIP.CompressType].SetCheck(1);

	//vZbggꍇɂ͖
	int Type=0;
	for(;Type<SEVEN_ZIP_COMPRESS_TYPE_MAX_NUM;Type++){
		Radio_CompressType[Type].EnableWindow(!Config.SEVEN_ZIP.UsePreset);
	}

	//------------------------------
	// kx̑I(vZbg)
	//------------------------------
	Radio_CompressLevel[SEVEN_ZIP_COMPRESS_LEVEL0]=GetDlgItem(IDC_RADIO_7Z_COMPRESS_LEVEL_0);
	Radio_CompressLevel[SEVEN_ZIP_COMPRESS_LEVEL1]=GetDlgItem(IDC_RADIO_7Z_COMPRESS_LEVEL_1);
	Radio_CompressLevel[SEVEN_ZIP_COMPRESS_LEVEL5]=GetDlgItem(IDC_RADIO_7Z_COMPRESS_LEVEL_5);
	Radio_CompressLevel[SEVEN_ZIP_COMPRESS_LEVEL7]=GetDlgItem(IDC_RADIO_7Z_COMPRESS_LEVEL_7);
	Radio_CompressLevel[SEVEN_ZIP_COMPRESS_LEVEL9]=GetDlgItem(IDC_RADIO_7Z_COMPRESS_LEVEL_9);

	Radio_CompressLevel[Config.SEVEN_ZIP.CompressLevel].SetCheck(1);
	//vZbggȂꍇɂ͖
	for(Type=0;Type<SEVEN_ZIP_COMPRESS_LEVEL_MAX_NUM;Type++){
		Radio_CompressLevel[Type].EnableWindow(Config.SEVEN_ZIP.UsePreset);
	}

	//----------------------
	// LZMAk[h̑I
	//----------------------
	Radio_LZMA_Mode[SEVEN_ZIP_LZMA_MODE0]=GetDlgItem(IDC_RADIO_7Z_LZMA_MODE0);
	Radio_LZMA_Mode[SEVEN_ZIP_LZMA_MODE1]=GetDlgItem(IDC_RADIO_7Z_LZMA_MODE1);
	Radio_LZMA_Mode[SEVEN_ZIP_LZMA_MODE2]=GetDlgItem(IDC_RADIO_7Z_LZMA_MODE2);

	Radio_LZMA_Mode[Config.SEVEN_ZIP.LZMA_Mode].SetCheck(1);
	//vZbggꍇɂ͖
	for(Type=0;Type<SEVEN_ZIP_LZMA_MODE_MAX_NUM;Type++){
		Radio_LZMA_Mode[Type].EnableWindow((SEVEN_ZIP_COMPRESS_LZMA==Config.SEVEN_ZIP.CompressType)&&(!Config.SEVEN_ZIP.UsePreset));
	}

	//------------
	// wb_k
	//------------
	Check_HeaderCompression=GetDlgItem(IDC_CHECK_7Z_HEADER_COMPRESSION);

	//------------
	// PPMd̐ݒ
	//------------
	//fTCY
	::SendMessage(GetDlgItem(IDC_EDIT_7Z_PPMD_MODEL_SIZE),EM_LIMITTEXT,2,NULL);
	Check_SpecifyPPMdModelSize=GetDlgItem(IDC_CHECK_7Z_SPECIFY_PPMD_MODEL_SIZE);
	Check_SpecifyPPMdModelSize.SetCheck(Config.SEVEN_ZIP.SpecifyPPMdModelSize);
	//vZbggꍇɂ͖
	Check_SpecifyPPMdModelSize.EnableWindow((SEVEN_ZIP_COMPRESS_PPMD==Config.SEVEN_ZIP.CompressType)&&!Config.SEVEN_ZIP.UsePreset);
	::EnableWindow(GetDlgItem(IDC_EDIT_7Z_PPMD_MODEL_SIZE),(SEVEN_ZIP_COMPRESS_PPMD==Config.SEVEN_ZIP.CompressType)&&Config.SEVEN_ZIP.SpecifyPPMdModelSize&&!Config.SEVEN_ZIP.UsePreset);

	//DDXAbvf[g
	DoDataExchange(FALSE);

	//wb_Sk̐ݒ
	::EnableWindow(GetDlgItem(IDC_CHECK_7Z_FULL_HEADER_COMPRESSION),Check_HeaderCompression.GetCheck());

	return TRUE;
}

LRESULT CConfig7Z::OnApply()
{
//===============================
// ݒConfigManagerɏ߂
//===============================
	//----------------
	// k`̑I
	//----------------
	//vZbggǂ
	Config.SEVEN_ZIP.UsePreset=Check_UsePreset.GetCheck();

	//蓮ݒ̏ꍇ
	int Type=0;
	for(;Type<SEVEN_ZIP_COMPRESS_TYPE_MAX_NUM;Type++){
		if(Radio_CompressType[Type].GetCheck()){
			Config.SEVEN_ZIP.CompressType=(SEVEN_ZIP_COMPRESS_TYPE)Type;
			break;
		}
	}

	//------------------
	// kx̑I
	//------------------
	for(Type=0;Type<SEVEN_ZIP_COMPRESS_LEVEL_MAX_NUM;Type++){
		if(Radio_CompressLevel[Type].GetCheck()){
			Config.SEVEN_ZIP.CompressLevel=(SEVEN_ZIP_COMPRESS_LEVEL)Type;
			break;
		}
	}

	//----------------------
	// LZMAk[h̑I
	//----------------------
	for(Type=0;Type<SEVEN_ZIP_LZMA_MODE_MAX_NUM;Type++){
		if(Radio_LZMA_Mode[Type].GetCheck()){
			Config.SEVEN_ZIP.LZMA_Mode=(SEVEN_ZIP_LZMA_MODE)Type;
			break;
		}
	}

	//---------------
	// DDXf[^XV
	//---------------
	if(!DoDataExchange(TRUE)){
		return FALSE;
	}
	//---------------
	// PPMd̐ݒ
	//---------------
	//fTCY
	Config.SEVEN_ZIP.SpecifyPPMdModelSize=Check_SpecifyPPMdModelSize.GetCheck();
//	Config.SEVEN_ZIP.PPMdModelSize=PPMdModelSize;
	return TRUE;
}

LRESULT CConfig7Z::OnUsePreset(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		int Type=0;
		for(;Type<SEVEN_ZIP_COMPRESS_TYPE_MAX_NUM;Type++){
			Radio_CompressType[Type].EnableWindow(!Check_UsePreset.GetCheck());
		}
		for(Type=0;Type<SEVEN_ZIP_COMPRESS_LEVEL_MAX_NUM;Type++){
			Radio_CompressLevel[Type].EnableWindow(Check_UsePreset.GetCheck());
		}
		for(Type=0;Type<SEVEN_ZIP_LZMA_MODE_MAX_NUM;Type++){
			Radio_LZMA_Mode[Type].EnableWindow(Radio_CompressType[SEVEN_ZIP_COMPRESS_LZMA].GetCheck()&&!Check_UsePreset.GetCheck());
		}
		Check_SpecifyPPMdModelSize.EnableWindow(Radio_CompressType[SEVEN_ZIP_COMPRESS_PPMD].GetCheck()&&!Check_UsePreset.GetCheck());
		::EnableWindow(GetDlgItem(IDC_EDIT_7Z_PPMD_MODEL_SIZE),Radio_CompressType[SEVEN_ZIP_COMPRESS_PPMD].GetCheck()&&Check_SpecifyPPMdModelSize.GetCheck()&&!Check_UsePreset.GetCheck());
	}
	return 0;
}

LRESULT CConfig7Z::OnSpecifyPPMdModelSize(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		::EnableWindow(GetDlgItem(IDC_EDIT_7Z_PPMD_MODEL_SIZE),(Check_SpecifyPPMdModelSize.GetCheck())&&(!Check_UsePreset.GetCheck()));
	}
	return 0;
}

LRESULT CConfig7Z::OnSelectCompressType(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		//LZMA
		for(int Type=0;Type<SEVEN_ZIP_LZMA_MODE_MAX_NUM;Type++){
			Radio_LZMA_Mode[Type].EnableWindow(Radio_CompressType[SEVEN_ZIP_COMPRESS_LZMA].GetCheck()&&!Check_UsePreset.GetCheck());
		}
		//PPMd
		Check_SpecifyPPMdModelSize.EnableWindow(Radio_CompressType[SEVEN_ZIP_COMPRESS_PPMD].GetCheck()&&!Check_UsePreset.GetCheck());
		::EnableWindow(GetDlgItem(IDC_EDIT_7Z_PPMD_MODEL_SIZE),Radio_CompressType[SEVEN_ZIP_COMPRESS_PPMD].GetCheck()&&Check_SpecifyPPMdModelSize.GetCheck()&&!Check_UsePreset.GetCheck());
	}
	return 0;
}

LRESULT CConfig7Z::OnHeaderCompression(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		::EnableWindow(GetDlgItem(IDC_CHECK_7Z_FULL_HEADER_COMPRESSION),Check_HeaderCompression.GetCheck());
	}
	return 0;
}

