#pragma once
#include "../resource.h"

class CWaitDialog : public CDialogImpl<CWaitDialog>,public CMessageFilter, public CIdleHandler
{
protected:
	CStatic	Static_MessageString;
	CStatic Static_Icon;
	std::vector<CIcon> m_IconArray;
	int m_CurrentIconNumber;
	DWORD m_LastTime;
	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CMainDlg)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
		COMMAND_ID_HANDLER_EX(IDOK, __noop)
		COMMAND_ID_HANDLER_EX(IDCANCEL, __noop)
	END_MSG_MAP()

    LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	void OnDestroy();

	BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

	BOOL OnIdle(){
		return FALSE;
	}
public:
	enum {IDD = IDD_DIALOG_WAIT};
	void SetMessageString(LPCTSTR t){Static_MessageString.SetWindowText(t);}
	inline void AnimationCall(){
		DWORD Now=timeGetTime();
		if(Now-m_LastTime<200)return;
		m_LastTime=Now;
		m_CurrentIconNumber++;
		m_CurrentIconNumber%=m_IconArray.size();
		Static_Icon.SetIcon(m_IconArray[m_CurrentIconNumber]);
	}
};
